SystemOrganization addCategory: #ExampleMesh!

Object subclass: #ExampleMesh
	instanceVariableNames: 'aMesh'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExampleMesh'!

!ExampleMesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 21:56'!
initialize 
	|response|
	self initializeHardcodeMesh.
	[(response := UIManager default chooseFrom: #('Area' 'Perimeter' 'Initialize Mesh' 'Exit')
											lines: #(2 3) message: 'Choose an action') = 4] whileFalse:
	[
		(response = 1)
			ifTrue: [UIManager default inform: 'Area: ',((aMesh getArea) printString)]
			ifFalse: [
						(response = 2)
							ifTrue: [UIManager default inform: 'Perimeter: ',((aMesh getPerimeter) printString)]
							ifFalse: [self initializeMesh]						
						]	
	]
	! !

!ExampleMesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 21:55'!
initializeHardcodeMesh
	|triangleA triangleB  triangleC  triangleD triangleE triangleSet|

	triangleSet := OrderedCollection new.

	triangleA := Triangle pointXY: 2@0 pointYZ: 3@2 pointZX: 0@3.	
	triangleB := Triangle pointXY: 3@2 pointYZ: 2@0 pointZX: 5@1.
	triangleC := Triangle pointXY: 3@2 pointYZ: 5@1 pointZX: 6@3.
	triangleD := Triangle pointXY: 5@1 pointYZ: 7@2 pointZX: 6@3.
	triangleE := Triangle pointXY: 0@3 pointYZ: 3@2 pointZX: 6@3.

	triangleSet add:triangleA.
	triangleSet add:triangleB.
	triangleSet add:triangleC.
	triangleSet add:triangleD.
	triangleSet add:triangleE.

	aMesh := Mesh createFromTriangles: triangleSet. ! !

!ExampleMesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 21:29'!
initializeMesh 
	|triangle pointA pointB pointC triangleSet stringA stringB stringC|
	triangleSet := OrderedCollection new.
	[UIManager default confirm: 'Add a triangle?'] whileTrue:
	[	
	pointA := Point new.
	pointA setX: ((UIManager default request: 'Set first point X coord' initialAnswer: '0') asInteger) 
			setY: ((UIManager default request: 'Set first point Y coord' initialAnswer: '0') asInteger).
	
	pointB := Point new.
	pointB setX: ((UIManager default request: 'Set second point X coord' initialAnswer: '0') asInteger) 
			setY: ((UIManager default request: 'Set second point Y coord' initialAnswer: '0') asInteger).
	
	pointC := Point new.
	pointC setX: ((UIManager default request: 'Set third point X coord' initialAnswer: '0') asInteger) 
			setY: ((UIManager default request: 'Set third point Y coord' initialAnswer: '0') asInteger).

	triangle := Triangle pointXY: pointA pointYZ: pointB pointZX: pointC.
	triangleSet add:triangle.
	].	

	aMesh := Mesh createFromTriangles: triangleSet. ! !

Object subclass: #Mesh
	instanceVariableNames: 'meshTriangles'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExampleMesh'!

!Mesh class methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 14:41'!
createFromTriangles: aTrianglesCollection
	| aMesh |
	aMesh := self new.
	aMesh meshTriangles: aTrianglesCollection.
	^aMesh 
	! !

!Mesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 16:30'!
getArea
	| area | 
	area :=	(meshTriangles inject: 0 into: [:sum :each | sum + (each getArea) ]).
	^area ! !

!Mesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 14:42'!
getPerimeter
	| linesCol line pointA pointB auxArray acum |
	linesCol := OrderedCollection  new.
	acum := 0.
	meshTriangles do:[:each | 	auxArray := #(1 2 3 1). 
									#(1 2 3)	do:[:index | 
														line := Array new: 2.
														pointA := (each vertexPoints) at: (auxArray at: index).
														pointB  := (each vertexPoints) at: (auxArray at: (index + 1)).
														((pointA x) < (pointB  x))
															ifTrue: [line at:1 put:pointA. line at:2 put:pointB]
															ifFalse: [	((pointA x)=(pointB x))
																			ifTrue: [(pointA y < pointB y)
																						ifTrue: [line at:1 put:pointA. line at:2 put:pointB]
																						ifFalse: [line at:1 put:pointB. line at:2 put:pointA]]
																			ifFalse: [line at:1 put:pointB. line at:2 put:pointA]
																		].
														linesCol add: line.
													].									
						].
	linesCol do:[:eachLine | ((linesCol occurrencesOf: eachLine)=1) 
										ifTrue: [acum := (acum + ((eachLine at:1) dist: (eachLine at:2) ))]].
	^acum
! !

!Mesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 10:32'!
initialize 
	super initialize.
	meshTriangles := OrderedCollection new
	! !

!Mesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 10:30'!
meshTriangles
	^meshTriangles! !

!Mesh methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/8/2013 10:31'!
meshTriangles: aTrianglesCol
	meshTriangles := aTrianglesCol! !

Object subclass: #Triangle
	instanceVariableNames: 'vertexPoints'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ExampleMesh'!

!Triangle class methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 14:39'!
pointXY: aPointXY pointYZ:aPointYZ pointZX:aPointZX
	| triangle aPointsCollection|
	triangle := self new.
	aPointsCollection := OrderedCollection new.
	aPointsCollection add: aPointXY; add: aPointYZ; add: aPointZX.
	triangle vertexPoints: aPointsCollection.
	^triangle! !

!Triangle methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 16:26'!
getArea
	| semiperimeter longA longB longC|
	longA := (vertexPoints at: 1) dist: (vertexPoints at:2).
	longB := (vertexPoints at: 1) dist: (vertexPoints at:3).
	longC := (vertexPoints at: 2) dist: (vertexPoints at:3).
	"
	vertexPoints inject:0 into:[:sum :each | sum + (each sqrt)].
	"
	semiperimeter := (longA + longB + longC)/2.
	^(semiperimeter * (semiperimeter - longA) * (semiperimeter -longB) * (semiperimeter - longC)) sqrt! !

!Triangle methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 14:31'!
initialize
	super initialize.
	vertexPoints := OrderedCollection new! !

!Triangle methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 13:12'!
vertexPoints
	^vertexPoints ! !

!Triangle methodsFor: 'as yet unclassified' stamp: 'JosePardo 5/7/2013 14:35'!
vertexPoints: aPointsCollection
	vertexPoints := aPointsCollection ! !
